

#include "smtp_parsers.h"
#include "content_type.h"


static const int content_type_parser_start = 1;
static const int content_type_parser_first_final = 23;
static const int content_type_parser_error = 0;

static const int content_type_parser_en_balanced_ccontent = 22;
static const int content_type_parser_en_main = 1;

static const char _content_type_parser_nfa_targs[] = {
	0, 0
};

static const char _content_type_parser_nfa_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0
};

static const char _content_type_parser_nfa_push_actions[] = {
	0, 0
};

static const char _content_type_parser_nfa_pop_trans[] = {
	0, 0
};



gboolean
rspamd_content_disposition_parser (const char *data, size_t len, struct rspamd_content_disposition *cd, rspamd_mempool_t *pool)
{
	const char *p = data, *pe = data + len, *eof, *qstart = NULL, *qend = NULL,
	*pname_start = NULL, *pname_end = NULL, *pvalue_start = NULL, *pvalue_end = NULL;
	int cs, *stack = NULL;
	gsize top=0;
	struct _ragel_st_storage {
		int *data;
		gsize size;
	} st_storage;
	
	memset (&st_storage, 0, sizeof (st_storage));
	memset (cd, 0, sizeof (*cd));
	eof = pe;
	
	
	{
		cs = (int)content_type_parser_start;
		top = 0;
	}
	
	
	{
		if ( p == pe )
		goto _test_eof;
		goto _resume;
		
		_again:
		switch ( cs ) {
			case 1: goto st1;
			case 0: goto st0;
			case 23: goto st23;
			case 2: goto st2;
			case 3: goto st3;
			case 4: goto st4;
			case 5: goto st5;
			case 24: goto st24;
			case 25: goto st25;
			case 6: goto st6;
			case 7: goto st7;
			case 8: goto st8;
			case 26: goto st26;
			case 9: goto st9;
			case 10: goto st10;
			case 11: goto st11;
			case 12: goto st12;
			case 13: goto st13;
			case 14: goto st14;
			case 27: goto st27;
			case 28: goto st28;
			case 15: goto st15;
			case 29: goto st29;
			case 30: goto st30;
			case 31: goto st31;
			case 32: goto st32;
			case 33: goto st33;
			case 16: goto st16;
			case 17: goto st17;
			case 18: goto st18;
			case 19: goto st19;
			case 20: goto st20;
			case 21: goto st21;
			case 34: goto st34;
			case 35: goto st35;
			case 36: goto st36;
			case 37: goto st37;
			case 38: goto st38;
			case 39: goto st39;
			case 40: goto st40;
			case 41: goto st41;
			case 42: goto st42;
			case 43: goto st43;
			case 44: goto st44;
			case 45: goto st45;
			case 46: goto st46;
			case 47: goto st47;
			case 48: goto st48;
			case 49: goto st49;
			case 22: goto st22;
			case 50: goto st50;
		}
		
		_resume:
		switch ( cs )
		{
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 23:
			goto st_case_23;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 24:
			goto st_case_24;
			case 25:
			goto st_case_25;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 26:
			goto st_case_26;
			case 9:
			goto st_case_9;
			case 10:
			goto st_case_10;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 27:
			goto st_case_27;
			case 28:
			goto st_case_28;
			case 15:
			goto st_case_15;
			case 29:
			goto st_case_29;
			case 30:
			goto st_case_30;
			case 31:
			goto st_case_31;
			case 32:
			goto st_case_32;
			case 33:
			goto st_case_33;
			case 16:
			goto st_case_16;
			case 17:
			goto st_case_17;
			case 18:
			goto st_case_18;
			case 19:
			goto st_case_19;
			case 20:
			goto st_case_20;
			case 21:
			goto st_case_21;
			case 34:
			goto st_case_34;
			case 35:
			goto st_case_35;
			case 36:
			goto st_case_36;
			case 37:
			goto st_case_37;
			case 38:
			goto st_case_38;
			case 39:
			goto st_case_39;
			case 40:
			goto st_case_40;
			case 41:
			goto st_case_41;
			case 42:
			goto st_case_42;
			case 43:
			goto st_case_43;
			case 44:
			goto st_case_44;
			case 45:
			goto st_case_45;
			case 46:
			goto st_case_46;
			case 47:
			goto st_case_47;
			case 48:
			goto st_case_48;
			case 49:
			goto st_case_49;
			case 22:
			goto st_case_22;
			case 50:
			goto st_case_50;
		}
		goto st_out;
		st1:
		p+= 1;
		if ( p == pe )
		goto _test_eof1;
		st_case_1:
		switch( ( (*( p))) ) {
			case 97: {
				goto ctr2;
			}
			case 105: {
				goto ctr3;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr0;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr0;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr0;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr0;
			}
		} else {
			goto ctr0;
		}
		{
			goto st0;
		}
		st_case_0:
		st0:
		cs = 0;
		goto _out;
		ctr0:
		{
			#line 4 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st23;
		st23:
		p+= 1;
		if ( p == pe )
		goto _test_eof23;
		st_case_23:
		if ( ( (*( p))) == 59 ) {
			goto ctr59;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		ctr4:
		{
			#line 18 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
		goto st2;
		ctr59:
		{
			#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st2;
		ctr63:
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st2;
		ctr85:
		{
			#line 14 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_ATTACHMENT;
		}
		{
			#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st2;
		ctr91:
		{
			#line 10 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_INLINE;
		}
		{
			#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st2;
		st2:
		p+= 1;
		if ( p == pe )
		goto _test_eof2;
		st_case_2:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr4;
			}
			case 34: {
				goto ctr6;
			}
			case 40: {
				goto ctr7;
			}
			case 61: {
				goto ctr5;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr5;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr5;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr5;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr5;
			}
		} else {
			goto ctr5;
		}
		{
			goto st0;
		}
		ctr5:
		{
			#line 18 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
		goto st3;
		st3:
		p+= 1;
		if ( p == pe )
		goto _test_eof3;
		st_case_3:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr8;
			}
			case 33: {
				goto st3;
			}
			case 61: {
				goto ctr10;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st3;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto st3;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st3;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st3;
			}
		} else {
			goto st3;
		}
		{
			goto st0;
		}
		ctr8:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
		goto st4;
		st4:
		p+= 1;
		if ( p == pe )
		goto _test_eof4;
		st_case_4:
		switch( ( (*( p))) ) {
			case 32: {
				goto st4;
			}
			case 61: {
				goto st5;
			}
		}
		{
			goto st0;
		}
		ctr49:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
		goto st5;
		ctr13:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st5;
		st5:
		p+= 1;
		if ( p == pe )
		goto _test_eof5;
		st_case_5:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr13;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr16;
			}
			case 61: {
				goto ctr14;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr14;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr14;
			}
		} else {
			goto ctr14;
		}
		{
			goto st0;
		}
		ctr14:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st24;
		st24:
		p+= 1;
		if ( p == pe )
		goto _test_eof24;
		st_case_24:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr60;
			}
			case 33: {
				goto st24;
			}
			case 40: {
				goto ctr62;
			}
			case 59: {
				goto ctr63;
			}
			case 61: {
				goto st24;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st24;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto st24;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st24;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st24;
			}
		} else {
			goto st24;
		}
		{
			goto st0;
		}
		ctr60:
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st25;
		st25:
		p+= 1;
		if ( p == pe )
		goto _test_eof25;
		st_case_25:
		switch( ( (*( p))) ) {
			case 32: {
				goto st25;
			}
			case 40: {
				goto st6;
			}
			case 59: {
				goto st2;
			}
		}
		{
			goto st0;
		}
		ctr18:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 6; top+= 1; goto st22;}}
		
		goto st6;
		ctr62:
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st6;
		st6:
		p+= 1;
		if ( p == pe )
		goto _test_eof6;
		st_case_6:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr18;
			}
			case 41: {
				goto st25;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st6;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st6;
		}
		{
			goto st0;
		}
		ctr15:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st7;
		st7:
		p+= 1;
		if ( p == pe )
		goto _test_eof7;
		st_case_7:
		switch( ( (*( p))) ) {
			case 34: {
				goto ctr21;
			}
			case 92: {
				goto ctr22;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto ctr20;
		}
		{
			goto st0;
		}
		ctr20:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
		goto st8;
		st8:
		p+= 1;
		if ( p == pe )
		goto _test_eof8;
		st_case_8:
		switch( ( (*( p))) ) {
			case 34: {
				goto ctr24;
			}
			case 92: {
				goto st10;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto st8;
		}
		{
			goto st0;
		}
		ctr21:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		{
			#line 83 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
		goto st26;
		ctr24:
		{
			#line 83 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
		goto st26;
		ctr64:
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st26;
		st26:
		p+= 1;
		if ( p == pe )
		goto _test_eof26;
		st_case_26:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr64;
			}
			case 40: {
				goto ctr65;
			}
			case 59: {
				goto ctr63;
			}
		}
		{
			goto st0;
		}
		ctr27:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 9; top+= 1; goto st22;}}
		
		goto st9;
		ctr65:
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st9;
		st9:
		p+= 1;
		if ( p == pe )
		goto _test_eof9;
		st_case_9:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr27;
			}
			case 41: {
				goto st26;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st9;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st9;
		}
		{
			goto st0;
		}
		ctr22:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
		goto st10;
		st10:
		p+= 1;
		if ( p == pe )
		goto _test_eof10;
		st_case_10:
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto st8;
		}
		{
			goto st0;
		}
		ctr16:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st11;
		ctr30:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 11; top+= 1; goto st22;}}
		
		goto st11;
		st11:
		p+= 1;
		if ( p == pe )
		goto _test_eof11;
		st_case_11:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr30;
			}
			case 41: {
				goto st12;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st11;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st11;
		}
		{
			goto st0;
		}
		st12:
		p+= 1;
		if ( p == pe )
		goto _test_eof12;
		st_case_12:
		switch( ( (*( p))) ) {
			case 32: {
				goto st12;
			}
			case 34: {
				goto st7;
			}
			case 40: {
				goto st11;
			}
		}
		{
			goto st0;
		}
		ctr10:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
		goto st13;
		st13:
		p+= 1;
		if ( p == pe )
		goto _test_eof13;
		st_case_13:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr33;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr16;
			}
			case 61: {
				goto ctr35;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr34;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr34;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr34;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr34;
			}
		} else {
			goto ctr34;
		}
		{
			goto st0;
		}
		ctr36:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st14;
		ctr33:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st14;
		st14:
		p+= 1;
		if ( p == pe )
		goto _test_eof14;
		st_case_14:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr36;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr16;
			}
			case 61: {
				goto ctr37;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr14;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr14;
			}
		} else {
			goto ctr14;
		}
		{
			goto st0;
		}
		ctr37:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st27;
		st27:
		p+= 1;
		if ( p == pe )
		goto _test_eof27;
		st_case_27:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr66;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr67;
			}
			case 59: {
				goto ctr63;
			}
			case 61: {
				goto ctr14;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr14;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr14;
			}
		} else {
			goto ctr14;
		}
		{
			goto st0;
		}
		ctr68:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st28;
		ctr66:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st28;
		st28:
		p+= 1;
		if ( p == pe )
		goto _test_eof28;
		st_case_28:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr68;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr69;
			}
			case 59: {
				goto st2;
			}
			case 61: {
				goto ctr14;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr14;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr14;
			}
		} else {
			goto ctr14;
		}
		{
			goto st0;
		}
		ctr69:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st15;
		ctr39:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 15; top+= 1; goto st22;}}
		
		goto st15;
		ctr67:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st15;
		st15:
		p+= 1;
		if ( p == pe )
		goto _test_eof15;
		st_case_15:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr39;
			}
			case 41: {
				goto st29;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st15;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st15;
		}
		{
			goto st0;
		}
		st29:
		p+= 1;
		if ( p == pe )
		goto _test_eof29;
		st_case_29:
		switch( ( (*( p))) ) {
			case 32: {
				goto st29;
			}
			case 34: {
				goto st7;
			}
			case 40: {
				goto st15;
			}
			case 59: {
				goto st2;
			}
		}
		{
			goto st0;
		}
		ctr34:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st30;
		st30:
		p+= 1;
		if ( p == pe )
		goto _test_eof30;
		st_case_30:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr70;
			}
			case 33: {
				goto st30;
			}
			case 40: {
				goto ctr62;
			}
			case 59: {
				goto ctr63;
			}
			case 61: {
				goto ctr72;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st30;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto st30;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st30;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st30;
			}
		} else {
			goto st30;
		}
		{
			goto st0;
		}
		ctr70:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st31;
		st31:
		p+= 1;
		if ( p == pe )
		goto _test_eof31;
		st_case_31:
		switch( ( (*( p))) ) {
			case 32: {
				goto st31;
			}
			case 40: {
				goto st6;
			}
			case 59: {
				goto st2;
			}
			case 61: {
				goto st5;
			}
		}
		{
			goto st0;
		}
		ctr72:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
		goto st32;
		ctr35:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st32;
		st32:
		p+= 1;
		if ( p == pe )
		goto _test_eof32;
		st_case_32:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr74;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr67;
			}
			case 59: {
				goto ctr63;
			}
			case 61: {
				goto ctr35;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr34;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr34;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr34;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr34;
			}
		} else {
			goto ctr34;
		}
		{
			goto st0;
		}
		ctr75:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
		goto st33;
		ctr74:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		{
			#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
		goto st33;
		st33:
		p+= 1;
		if ( p == pe )
		goto _test_eof33;
		st_case_33:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr75;
			}
			case 34: {
				goto ctr15;
			}
			case 40: {
				goto ctr69;
			}
			case 59: {
				goto st2;
			}
			case 61: {
				goto ctr37;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto ctr14;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr14;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr14;
			}
		} else {
			goto ctr14;
		}
		{
			goto st0;
		}
		ctr6:
		{
			#line 18 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
		goto st16;
		st16:
		p+= 1;
		if ( p == pe )
		goto _test_eof16;
		st_case_16:
		switch( ( (*( p))) ) {
			case 34: {
				goto ctr42;
			}
			case 92: {
				goto ctr43;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto ctr41;
		}
		{
			goto st0;
		}
		ctr41:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
		goto st17;
		st17:
		p+= 1;
		if ( p == pe )
		goto _test_eof17;
		st_case_17:
		switch( ( (*( p))) ) {
			case 34: {
				goto ctr45;
			}
			case 92: {
				goto st20;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto st17;
		}
		{
			goto st0;
		}
		ctr47:
		{
			#line 25 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
		goto st18;
		ctr42:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		{
			#line 83 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
		goto st18;
		ctr45:
		{
			#line 83 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
		goto st18;
		st18:
		p+= 1;
		if ( p == pe )
		goto _test_eof18;
		st_case_18:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr47;
			}
			case 40: {
				goto st19;
			}
			case 61: {
				goto ctr49;
			}
		}
		{
			goto st0;
		}
		ctr50:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 19; top+= 1; goto st22;}}
		
		goto st19;
		st19:
		p+= 1;
		if ( p == pe )
		goto _test_eof19;
		st_case_19:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr50;
			}
			case 41: {
				goto st18;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st19;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st19;
		}
		{
			goto st0;
		}
		ctr43:
		{
			#line 78 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
		goto st20;
		st20:
		p+= 1;
		if ( p == pe )
		goto _test_eof20;
		st_case_20:
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto st17;
		}
		{
			goto st0;
		}
		ctr7:
		{
			#line 18 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
		goto st21;
		ctr53:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 21; top+= 1; goto st22;}}
		
		goto st21;
		st21:
		p+= 1;
		if ( p == pe )
		goto _test_eof21;
		st_case_21:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr53;
			}
			case 41: {
				goto st2;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st21;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st21;
		}
		{
			goto st0;
		}
		ctr2:
		{
			#line 4 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st34;
		st34:
		p+= 1;
		if ( p == pe )
		goto _test_eof34;
		st_case_34:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 116: {
				goto st35;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st35:
		p+= 1;
		if ( p == pe )
		goto _test_eof35;
		st_case_35:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 116: {
				goto st36;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st36:
		p+= 1;
		if ( p == pe )
		goto _test_eof36;
		st_case_36:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 97: {
				goto st37;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st37:
		p+= 1;
		if ( p == pe )
		goto _test_eof37;
		st_case_37:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 99: {
				goto st38;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st38:
		p+= 1;
		if ( p == pe )
		goto _test_eof38;
		st_case_38:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 104: {
				goto st39;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st39:
		p+= 1;
		if ( p == pe )
		goto _test_eof39;
		st_case_39:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 109: {
				goto st40;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st40:
		p+= 1;
		if ( p == pe )
		goto _test_eof40;
		st_case_40:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 101: {
				goto st41;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st41:
		p+= 1;
		if ( p == pe )
		goto _test_eof41;
		st_case_41:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 110: {
				goto st42;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st42:
		p+= 1;
		if ( p == pe )
		goto _test_eof42;
		st_case_42:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 116: {
				goto st43;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st43:
		p+= 1;
		if ( p == pe )
		goto _test_eof43;
		st_case_43:
		if ( ( (*( p))) == 59 ) {
			goto ctr85;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		ctr3:
		{
			#line 4 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
			
		}
		
		goto st44;
		st44:
		p+= 1;
		if ( p == pe )
		goto _test_eof44;
		st_case_44:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 110: {
				goto st45;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st45:
		p+= 1;
		if ( p == pe )
		goto _test_eof45;
		st_case_45:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 108: {
				goto st46;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st46:
		p+= 1;
		if ( p == pe )
		goto _test_eof46;
		st_case_46:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 105: {
				goto st47;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st47:
		p+= 1;
		if ( p == pe )
		goto _test_eof47;
		st_case_47:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 110: {
				goto st48;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st48:
		p+= 1;
		if ( p == pe )
		goto _test_eof48;
		st_case_48:
		switch( ( (*( p))) ) {
			case 59: {
				goto ctr59;
			}
			case 101: {
				goto st49;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		st49:
		p+= 1;
		if ( p == pe )
		goto _test_eof49;
		st_case_49:
		if ( ( (*( p))) == 59 ) {
			goto ctr91;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st23;
			}
		} else {
			goto st23;
		}
		{
			goto st0;
		}
		ctr56:
		{
			#line 6 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{{
					#line 28 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}stack[top] = 22; top+= 1; goto st22;}}
		
		goto st22;
		st22:
		p+= 1;
		if ( p == pe )
		goto _test_eof22;
		st_case_22:
		switch( ( (*( p))) ) {
			case 40: {
				goto ctr56;
			}
			case 41: {
				goto ctr57;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto st22;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto st22;
		}
		{
			goto st0;
		}
		ctr57:
		{
			#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition.rl"
			{top -= 1;cs = stack[top];goto _again;} }
		
		goto st50;
		st50:
		p+= 1;
		if ( p == pe )
		goto _test_eof50;
		st_case_50:
		{
			goto st0;
		}
		st_out:
		_test_eof1: cs = 1; goto _test_eof; 
		_test_eof23: cs = 23; goto _test_eof; 
		_test_eof2: cs = 2; goto _test_eof; 
		_test_eof3: cs = 3; goto _test_eof; 
		_test_eof4: cs = 4; goto _test_eof; 
		_test_eof5: cs = 5; goto _test_eof; 
		_test_eof24: cs = 24; goto _test_eof; 
		_test_eof25: cs = 25; goto _test_eof; 
		_test_eof6: cs = 6; goto _test_eof; 
		_test_eof7: cs = 7; goto _test_eof; 
		_test_eof8: cs = 8; goto _test_eof; 
		_test_eof26: cs = 26; goto _test_eof; 
		_test_eof9: cs = 9; goto _test_eof; 
		_test_eof10: cs = 10; goto _test_eof; 
		_test_eof11: cs = 11; goto _test_eof; 
		_test_eof12: cs = 12; goto _test_eof; 
		_test_eof13: cs = 13; goto _test_eof; 
		_test_eof14: cs = 14; goto _test_eof; 
		_test_eof27: cs = 27; goto _test_eof; 
		_test_eof28: cs = 28; goto _test_eof; 
		_test_eof15: cs = 15; goto _test_eof; 
		_test_eof29: cs = 29; goto _test_eof; 
		_test_eof30: cs = 30; goto _test_eof; 
		_test_eof31: cs = 31; goto _test_eof; 
		_test_eof32: cs = 32; goto _test_eof; 
		_test_eof33: cs = 33; goto _test_eof; 
		_test_eof16: cs = 16; goto _test_eof; 
		_test_eof17: cs = 17; goto _test_eof; 
		_test_eof18: cs = 18; goto _test_eof; 
		_test_eof19: cs = 19; goto _test_eof; 
		_test_eof20: cs = 20; goto _test_eof; 
		_test_eof21: cs = 21; goto _test_eof; 
		_test_eof34: cs = 34; goto _test_eof; 
		_test_eof35: cs = 35; goto _test_eof; 
		_test_eof36: cs = 36; goto _test_eof; 
		_test_eof37: cs = 37; goto _test_eof; 
		_test_eof38: cs = 38; goto _test_eof; 
		_test_eof39: cs = 39; goto _test_eof; 
		_test_eof40: cs = 40; goto _test_eof; 
		_test_eof41: cs = 41; goto _test_eof; 
		_test_eof42: cs = 42; goto _test_eof; 
		_test_eof43: cs = 43; goto _test_eof; 
		_test_eof44: cs = 44; goto _test_eof; 
		_test_eof45: cs = 45; goto _test_eof; 
		_test_eof46: cs = 46; goto _test_eof; 
		_test_eof47: cs = 47; goto _test_eof; 
		_test_eof48: cs = 48; goto _test_eof; 
		_test_eof49: cs = 49; goto _test_eof; 
		_test_eof22: cs = 22; goto _test_eof; 
		_test_eof50: cs = 50; goto _test_eof; 
		
		_test_eof: {}
		if ( p == eof )
		{
			switch ( cs ) {
				case 1: {
					
					break; }
				case 0: {
					
					break; }
				case 23: {
					
					break; }
				case 2: {
					
					break; }
				case 3: {
					
					break; }
				case 4: {
					
					break; }
				case 5: {
					
					break; }
				case 24: {
					
					break; }
				case 25: {
					
					break; }
				case 6: {
					
					break; }
				case 7: {
					
					break; }
				case 8: {
					
					break; }
				case 26: {
					
					break; }
				case 9: {
					
					break; }
				case 10: {
					
					break; }
				case 11: {
					
					break; }
				case 12: {
					
					break; }
				case 13: {
					
					break; }
				case 14: {
					
					break; }
				case 27: {
					
					break; }
				case 28: {
					
					break; }
				case 15: {
					
					break; }
				case 29: {
					
					break; }
				case 30: {
					
					break; }
				case 31: {
					
					break; }
				case 32: {
					
					break; }
				case 33: {
					
					break; }
				case 16: {
					
					break; }
				case 17: {
					
					break; }
				case 18: {
					
					break; }
				case 19: {
					
					break; }
				case 20: {
					
					break; }
				case 21: {
					
					break; }
				case 34: {
					
					break; }
				case 35: {
					
					break; }
				case 36: {
					
					break; }
				case 37: {
					
					break; }
				case 38: {
					
					break; }
				case 39: {
					
					break; }
				case 40: {
					
					break; }
				case 41: {
					
					break; }
				case 42: {
					
					break; }
				case 43: {
					
					break; }
				case 44: {
					
					break; }
				case 45: {
					
					break; }
				case 46: {
					
					break; }
				case 47: {
					
					break; }
				case 48: {
					
					break; }
				case 49: {
					
					break; }
				case 22: {
					
					break; }
				case 50: {
					
					break; }
			}
			switch ( cs ) {
			}
			switch ( cs ) {
				case 23: 
				
				case 34: 
				
				case 35: 
				
				case 36: 
				
				case 37: 
				
				case 38: 
				
				case 39: 
				
				case 40: 
				
				case 41: 
				
				case 42: 
				
				case 44: 
				
				case 45: 
				
				case 46: 
				
				case 47: 
				
				case 48: 
				{
					#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
				}
				break;
				case 24: 
				
				case 26: 
				
				case 27: 
				
				case 30: 
				
				case 32: 
				{
					#line 51 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
					if (pname_end) {
						if (qstart) {
							pvalue_start = qstart;
						}
						if (qend && qend >= qstart) {
							pvalue_end = qend;
						}
						else if (p >= pvalue_start) {
							pvalue_end = p;
						}
						qstart = NULL;
						qend = NULL;
						
						if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
							rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
						}
					}
					
					pname_start = NULL;
					pname_end = NULL;
					pvalue_start = NULL;
					pvalue_end = NULL;
					qend = NULL;
					qstart = NULL;
				}
				break;
				case 49: 
				{
					#line 10 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
					cd->type = RSPAMD_CT_INLINE;
				}	{
					#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
				}
				break;
				case 43: 
				{
					#line 14 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
					cd->type = RSPAMD_CT_ATTACHMENT;
				}	{
					#line 7 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/content_disposition_parser.rl"
					
				}
				break;
			}
		}
		
		_out: {}
	}
	
	
	if (st_storage.data) {
		free (st_storage.data);
	}
	
	return cd->type != RSPAMD_CT_UNKNOWN;
}
