

#include "smtp_parsers.h"
#include "util.h"


static const int smtp_date_parser_start = 1;
static const int smtp_date_parser_first_final = 76;
static const int smtp_date_parser_error = 0;

static const int smtp_date_parser_en_main = 1;

static const char _smtp_date_parser_nfa_targs[] = {
	0, 0
};

static const char _smtp_date_parser_nfa_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0
};

static const char _smtp_date_parser_nfa_push_actions[] = {
	0, 0
};

static const char _smtp_date_parser_nfa_pop_trans[] = {
	0, 0
};



guint64
rspamd_parse_smtp_date (const char *data, size_t len)
{
	const gchar *p = data, *pe = data + len, *eof = data + len, *tmp = data;
	struct tm tm;
	glong tz=0;
	gint cs=0;
	
	memset (&tm, 0, sizeof (tm));
	
	
	{
		cs = (int)smtp_date_parser_start;
	}
	
	
	{
		if ( p == pe )
		goto _test_eof;
		switch ( cs )
		{
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 9:
			goto st_case_9;
			case 10:
			goto st_case_10;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 15:
			goto st_case_15;
			case 16:
			goto st_case_16;
			case 17:
			goto st_case_17;
			case 18:
			goto st_case_18;
			case 19:
			goto st_case_19;
			case 20:
			goto st_case_20;
			case 76:
			goto st_case_76;
			case 77:
			goto st_case_77;
			case 21:
			goto st_case_21;
			case 22:
			goto st_case_22;
			case 23:
			goto st_case_23;
			case 78:
			goto st_case_78;
			case 79:
			goto st_case_79;
			case 24:
			goto st_case_24;
			case 80:
			goto st_case_80;
			case 25:
			goto st_case_25;
			case 81:
			goto st_case_81;
			case 82:
			goto st_case_82;
			case 26:
			goto st_case_26;
			case 83:
			goto st_case_83;
			case 27:
			goto st_case_27;
			case 84:
			goto st_case_84;
			case 85:
			goto st_case_85;
			case 28:
			goto st_case_28;
			case 86:
			goto st_case_86;
			case 87:
			goto st_case_87;
			case 29:
			goto st_case_29;
			case 88:
			goto st_case_88;
			case 30:
			goto st_case_30;
			case 89:
			goto st_case_89;
			case 90:
			goto st_case_90;
			case 31:
			goto st_case_31;
			case 91:
			goto st_case_91;
			case 32:
			goto st_case_32;
			case 92:
			goto st_case_92;
			case 93:
			goto st_case_93;
			case 94:
			goto st_case_94;
			case 33:
			goto st_case_33;
			case 34:
			goto st_case_34;
			case 35:
			goto st_case_35;
			case 36:
			goto st_case_36;
			case 37:
			goto st_case_37;
			case 38:
			goto st_case_38;
			case 39:
			goto st_case_39;
			case 40:
			goto st_case_40;
			case 41:
			goto st_case_41;
			case 42:
			goto st_case_42;
			case 43:
			goto st_case_43;
			case 44:
			goto st_case_44;
			case 45:
			goto st_case_45;
			case 46:
			goto st_case_46;
			case 47:
			goto st_case_47;
			case 48:
			goto st_case_48;
			case 49:
			goto st_case_49;
			case 50:
			goto st_case_50;
			case 51:
			goto st_case_51;
			case 52:
			goto st_case_52;
			case 53:
			goto st_case_53;
			case 54:
			goto st_case_54;
			case 55:
			goto st_case_55;
			case 56:
			goto st_case_56;
			case 57:
			goto st_case_57;
			case 58:
			goto st_case_58;
			case 59:
			goto st_case_59;
			case 60:
			goto st_case_60;
			case 61:
			goto st_case_61;
			case 62:
			goto st_case_62;
			case 63:
			goto st_case_63;
			case 64:
			goto st_case_64;
			case 65:
			goto st_case_65;
			case 66:
			goto st_case_66;
			case 67:
			goto st_case_67;
			case 68:
			goto st_case_68;
			case 69:
			goto st_case_69;
			case 70:
			goto st_case_70;
			case 71:
			goto st_case_71;
			case 72:
			goto st_case_72;
			case 73:
			goto st_case_73;
			case 74:
			goto st_case_74;
			case 75:
			goto st_case_75;
		}
		goto st_out;
		st1:
		p+= 1;
		if ( p == pe )
		goto _test_eof1;
		st_case_1:
		switch( ( (*( p))) ) {
			case 32: {
				goto st1;
			}
			case 70: {
				goto st63;
			}
			case 77: {
				goto st67;
			}
			case 83: {
				goto st69;
			}
			case 84: {
				goto st71;
			}
			case 87: {
				goto st74;
			}
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr2;
		}
		{
			goto st0;
		}
		st_case_0:
		st0:
		cs = 0;
		goto _out;
		ctr2:
		{
			#line 8 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
		goto st2;
		st2:
		p+= 1;
		if ( p == pe )
		goto _test_eof2;
		st_case_2:
		if ( ( (*( p))) == 32 ) {
			goto ctr8;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st62;
		}
		{
			goto st0;
		}
		ctr8:
		{
			#line 11 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n > 0 && n <= 31) {
						tm.tm_mday = n;
					}
				}
			}
		}
		
		goto st3;
		st3:
		p+= 1;
		if ( p == pe )
		goto _test_eof3;
		st_case_3:
		switch( ( (*( p))) ) {
			case 32: {
				goto st3;
			}
			case 65: {
				goto st4;
			}
			case 68: {
				goto st37;
			}
			case 70: {
				goto st40;
			}
			case 74: {
				goto st43;
			}
			case 77: {
				goto st49;
			}
			case 78: {
				goto st53;
			}
			case 79: {
				goto st56;
			}
			case 83: {
				goto st59;
			}
		}
		{
			goto st0;
		}
		st4:
		p+= 1;
		if ( p == pe )
		goto _test_eof4;
		st_case_4:
		switch( ( (*( p))) ) {
			case 112: {
				goto st5;
			}
			case 117: {
				goto st35;
			}
		}
		{
			goto st0;
		}
		st5:
		p+= 1;
		if ( p == pe )
		goto _test_eof5;
		st_case_5:
		if ( ( (*( p))) == 114 ) {
			goto st6;
		}
		{
			goto st0;
		}
		st6:
		p+= 1;
		if ( p == pe )
		goto _test_eof6;
		st_case_6:
		if ( ( (*( p))) == 32 ) {
			goto ctr22;
		}
		{
			goto st0;
		}
		ctr22:
		{
			#line 110 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 3;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr70:
		{
			#line 122 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 7;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr73:
		{
			#line 134 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 11;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr76:
		{
			#line 104 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 1;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr80:
		{
			#line 101 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 0;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr83:
		{
			#line 119 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 6;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr84:
		{
			#line 116 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 5;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr88:
		{
			#line 107 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 2;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr89:
		{
			#line 113 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 4;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr92:
		{
			#line 131 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 10;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr95:
		{
			#line 128 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 9;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		ctr98:
		{
			#line 125 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 8;
		}
		{
			#line 21 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st7;
		st7:
		p+= 1;
		if ( p == pe )
		goto _test_eof7;
		st_case_7:
		if ( ( (*( p))) == 32 ) {
			goto st7;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr24;
		}
		{
			goto st0;
		}
		ctr24:
		{
			#line 24 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
		goto st8;
		st8:
		p+= 1;
		if ( p == pe )
		goto _test_eof8;
		st_case_8:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st9;
		}
		{
			goto st0;
		}
		st9:
		p+= 1;
		if ( p == pe )
		goto _test_eof9;
		st_case_9:
		if ( ( (*( p))) == 32 ) {
			goto ctr26;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st33;
		}
		{
			goto st0;
		}
		ctr26:
		{
			#line 27 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 1000) {
						tm.tm_year = n;
					}
					else {
						tm.tm_year = n - 1900;
					}
				}
			}
		}
		
		goto st10;
		st10:
		p+= 1;
		if ( p == pe )
		goto _test_eof10;
		st_case_10:
		if ( ( (*( p))) == 32 ) {
			goto st10;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr29;
		}
		{
			goto st0;
		}
		ctr29:
		{
			#line 40 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
		goto st11;
		st11:
		p+= 1;
		if ( p == pe )
		goto _test_eof11;
		st_case_11:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st12;
		}
		{
			goto st0;
		}
		st12:
		p+= 1;
		if ( p == pe )
		goto _test_eof12;
		st_case_12:
		if ( ( (*( p))) == 58 ) {
			goto ctr31;
		}
		{
			goto st0;
		}
		ctr31:
		{
			#line 43 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 24) {
						tm.tm_hour = n;
					}
				}
			}
		}
		
		goto st13;
		st13:
		p+= 1;
		if ( p == pe )
		goto _test_eof13;
		st_case_13:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr32;
		}
		{
			goto st0;
		}
		ctr32:
		{
			#line 53 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
		goto st14;
		st14:
		p+= 1;
		if ( p == pe )
		goto _test_eof14;
		st_case_14:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st15;
		}
		{
			goto st0;
		}
		st15:
		p+= 1;
		if ( p == pe )
		goto _test_eof15;
		st_case_15:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr34;
			}
			case 58: {
				goto ctr35;
			}
			case 67: {
				goto ctr37;
			}
			case 69: {
				goto ctr38;
			}
			case 71: {
				goto ctr39;
			}
			case 77: {
				goto ctr40;
			}
			case 80: {
				goto ctr41;
			}
			case 85: {
				goto ctr42;
			}
		}
		if ( ( (*( p))) < 75 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 73 ) {
				goto ctr36;
			}
		} else if ( ( (*( p))) > 90 ) {
			if ( ( (*( p))) > 105 ) {
				if ( 107 <= ( (*( p))) && ( (*( p))) <= 122 ) {
					goto ctr36;
				}
			} else if ( ( (*( p))) >= 97 ) {
				goto ctr36;
			}
		} else {
			goto ctr36;
		}
		{
			goto st0;
		}
		ctr34:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st16;
		ctr51:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st16;
		st16:
		p+= 1;
		if ( p == pe )
		goto _test_eof16;
		st_case_16:
		switch( ( (*( p))) ) {
			case 32: {
				goto st16;
			}
			case 43: {
				goto st17;
			}
			case 45: {
				goto st17;
			}
		}
		{
			goto st0;
		}
		st17:
		p+= 1;
		if ( p == pe )
		goto _test_eof17;
		st_case_17:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr45;
		}
		{
			goto st0;
		}
		ctr45:
		{
			#line 79 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		{
			#line 82 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			
		}
		
		goto st18;
		st18:
		p+= 1;
		if ( p == pe )
		goto _test_eof18;
		st_case_18:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st19;
		}
		{
			goto st0;
		}
		st19:
		p+= 1;
		if ( p == pe )
		goto _test_eof19;
		st_case_19:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st20;
		}
		{
			goto st0;
		}
		st20:
		p+= 1;
		if ( p == pe )
		goto _test_eof20;
		st_case_20:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st76;
		}
		{
			goto st0;
		}
		st76:
		p+= 1;
		if ( p == pe )
		goto _test_eof76;
		st_case_76:
		if ( ( (*( p))) == 32 ) {
			goto ctr107;
		}
		{
			goto st0;
		}
		ctr107:
		{
			#line 85 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);
				
				if (*(tmp - 1) == '-') {
					tz = -(tz);
				}
			}
		}
		
		goto st77;
		ctr109:
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr112:
		{
			#line 153 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr113:
		{
			#line 150 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr116:
		{
			#line 147 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -400;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr117:
		{
			#line 144 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr119:
		{
			#line 141 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr122:
		{
			#line 159 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr123:
		{
			#line 156 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr126:
		{
			#line 165 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr127:
		{
			#line 162 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = -800;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		ctr129:
		{
			#line 138 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		{
			#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st77;
		st77:
		p+= 1;
		if ( p == pe )
		goto _test_eof77;
		st_case_77:
		if ( ( (*( p))) == 32 ) {
			goto st77;
		}
		{
			goto st0;
		}
		ctr35:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		
		goto st21;
		st21:
		p+= 1;
		if ( p == pe )
		goto _test_eof21;
		st_case_21:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr49;
		}
		{
			goto st0;
		}
		ctr49:
		{
			#line 66 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
		goto st22;
		st22:
		p+= 1;
		if ( p == pe )
		goto _test_eof22;
		st_case_22:
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st23;
		}
		{
			goto st0;
		}
		st23:
		p+= 1;
		if ( p == pe )
		goto _test_eof23;
		st_case_23:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr51;
			}
			case 67: {
				goto ctr53;
			}
			case 69: {
				goto ctr54;
			}
			case 71: {
				goto ctr55;
			}
			case 77: {
				goto ctr56;
			}
			case 80: {
				goto ctr57;
			}
			case 85: {
				goto ctr58;
			}
		}
		if ( ( (*( p))) < 75 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 73 ) {
				goto ctr52;
			}
		} else if ( ( (*( p))) > 90 ) {
			if ( ( (*( p))) > 105 ) {
				if ( 107 <= ( (*( p))) && ( (*( p))) <= 122 ) {
					goto ctr52;
				}
			} else if ( ( (*( p))) >= 97 ) {
				goto ctr52;
			}
		} else {
			goto ctr52;
		}
		{
			goto st0;
		}
		ctr36:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st78;
		ctr52:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st78;
		st78:
		p+= 1;
		if ( p == pe )
		goto _test_eof78;
		st_case_78:
		if ( ( (*( p))) == 32 ) {
			goto ctr109;
		}
		{
			goto st0;
		}
		ctr37:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st79;
		ctr53:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st79;
		st79:
		p+= 1;
		if ( p == pe )
		goto _test_eof79;
		st_case_79:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 68: {
				goto st24;
			}
			case 83: {
				goto st25;
			}
		}
		{
			goto st0;
		}
		st24:
		p+= 1;
		if ( p == pe )
		goto _test_eof24;
		st_case_24:
		if ( ( (*( p))) == 84 ) {
			goto st80;
		}
		{
			goto st0;
		}
		st80:
		p+= 1;
		if ( p == pe )
		goto _test_eof80;
		st_case_80:
		if ( ( (*( p))) == 32 ) {
			goto ctr112;
		}
		{
			goto st0;
		}
		st25:
		p+= 1;
		if ( p == pe )
		goto _test_eof25;
		st_case_25:
		if ( ( (*( p))) == 84 ) {
			goto st81;
		}
		{
			goto st0;
		}
		st81:
		p+= 1;
		if ( p == pe )
		goto _test_eof81;
		st_case_81:
		if ( ( (*( p))) == 32 ) {
			goto ctr113;
		}
		{
			goto st0;
		}
		ctr38:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st82;
		ctr54:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st82;
		st82:
		p+= 1;
		if ( p == pe )
		goto _test_eof82;
		st_case_82:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 68: {
				goto st26;
			}
			case 83: {
				goto st27;
			}
		}
		{
			goto st0;
		}
		st26:
		p+= 1;
		if ( p == pe )
		goto _test_eof26;
		st_case_26:
		if ( ( (*( p))) == 84 ) {
			goto st83;
		}
		{
			goto st0;
		}
		st83:
		p+= 1;
		if ( p == pe )
		goto _test_eof83;
		st_case_83:
		if ( ( (*( p))) == 32 ) {
			goto ctr116;
		}
		{
			goto st0;
		}
		st27:
		p+= 1;
		if ( p == pe )
		goto _test_eof27;
		st_case_27:
		if ( ( (*( p))) == 84 ) {
			goto st84;
		}
		{
			goto st0;
		}
		st84:
		p+= 1;
		if ( p == pe )
		goto _test_eof84;
		st_case_84:
		if ( ( (*( p))) == 32 ) {
			goto ctr117;
		}
		{
			goto st0;
		}
		ctr39:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st85;
		ctr55:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st85;
		st85:
		p+= 1;
		if ( p == pe )
		goto _test_eof85;
		st_case_85:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 77: {
				goto st28;
			}
		}
		{
			goto st0;
		}
		st28:
		p+= 1;
		if ( p == pe )
		goto _test_eof28;
		st_case_28:
		if ( ( (*( p))) == 84 ) {
			goto st86;
		}
		{
			goto st0;
		}
		st86:
		p+= 1;
		if ( p == pe )
		goto _test_eof86;
		st_case_86:
		if ( ( (*( p))) == 32 ) {
			goto ctr119;
		}
		{
			goto st0;
		}
		ctr40:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st87;
		ctr56:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st87;
		st87:
		p+= 1;
		if ( p == pe )
		goto _test_eof87;
		st_case_87:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 68: {
				goto st29;
			}
			case 83: {
				goto st30;
			}
		}
		{
			goto st0;
		}
		st29:
		p+= 1;
		if ( p == pe )
		goto _test_eof29;
		st_case_29:
		if ( ( (*( p))) == 84 ) {
			goto st88;
		}
		{
			goto st0;
		}
		st88:
		p+= 1;
		if ( p == pe )
		goto _test_eof88;
		st_case_88:
		if ( ( (*( p))) == 32 ) {
			goto ctr122;
		}
		{
			goto st0;
		}
		st30:
		p+= 1;
		if ( p == pe )
		goto _test_eof30;
		st_case_30:
		if ( ( (*( p))) == 84 ) {
			goto st89;
		}
		{
			goto st0;
		}
		st89:
		p+= 1;
		if ( p == pe )
		goto _test_eof89;
		st_case_89:
		if ( ( (*( p))) == 32 ) {
			goto ctr123;
		}
		{
			goto st0;
		}
		ctr41:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st90;
		ctr57:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st90;
		st90:
		p+= 1;
		if ( p == pe )
		goto _test_eof90;
		st_case_90:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 68: {
				goto st31;
			}
			case 83: {
				goto st32;
			}
		}
		{
			goto st0;
		}
		st31:
		p+= 1;
		if ( p == pe )
		goto _test_eof31;
		st_case_31:
		if ( ( (*( p))) == 84 ) {
			goto st91;
		}
		{
			goto st0;
		}
		st91:
		p+= 1;
		if ( p == pe )
		goto _test_eof91;
		st_case_91:
		if ( ( (*( p))) == 32 ) {
			goto ctr126;
		}
		{
			goto st0;
		}
		st32:
		p+= 1;
		if ( p == pe )
		goto _test_eof32;
		st_case_32:
		if ( ( (*( p))) == 84 ) {
			goto st92;
		}
		{
			goto st0;
		}
		st92:
		p+= 1;
		if ( p == pe )
		goto _test_eof92;
		st_case_92:
		if ( ( (*( p))) == 32 ) {
			goto ctr127;
		}
		{
			goto st0;
		}
		ctr42:
		{
			#line 56 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st93;
		ctr58:
		{
			#line 69 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
				}
			}
		}
		{
			#line 96 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
			
		}
		
		goto st93;
		st93:
		p+= 1;
		if ( p == pe )
		goto _test_eof93;
		st_case_93:
		switch( ( (*( p))) ) {
			case 32: {
				goto ctr109;
			}
			case 84: {
				goto st94;
			}
		}
		{
			goto st0;
		}
		st94:
		p+= 1;
		if ( p == pe )
		goto _test_eof94;
		st_case_94:
		if ( ( (*( p))) == 32 ) {
			goto ctr129;
		}
		{
			goto st0;
		}
		st33:
		p+= 1;
		if ( p == pe )
		goto _test_eof33;
		st_case_33:
		if ( ( (*( p))) == 32 ) {
			goto ctr26;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto st34;
		}
		{
			goto st0;
		}
		st34:
		p+= 1;
		if ( p == pe )
		goto _test_eof34;
		st_case_34:
		if ( ( (*( p))) == 32 ) {
			goto ctr26;
		}
		{
			goto st0;
		}
		st35:
		p+= 1;
		if ( p == pe )
		goto _test_eof35;
		st_case_35:
		if ( ( (*( p))) == 103 ) {
			goto st36;
		}
		{
			goto st0;
		}
		st36:
		p+= 1;
		if ( p == pe )
		goto _test_eof36;
		st_case_36:
		if ( ( (*( p))) == 32 ) {
			goto ctr70;
		}
		{
			goto st0;
		}
		st37:
		p+= 1;
		if ( p == pe )
		goto _test_eof37;
		st_case_37:
		if ( ( (*( p))) == 101 ) {
			goto st38;
		}
		{
			goto st0;
		}
		st38:
		p+= 1;
		if ( p == pe )
		goto _test_eof38;
		st_case_38:
		if ( ( (*( p))) == 99 ) {
			goto st39;
		}
		{
			goto st0;
		}
		st39:
		p+= 1;
		if ( p == pe )
		goto _test_eof39;
		st_case_39:
		if ( ( (*( p))) == 32 ) {
			goto ctr73;
		}
		{
			goto st0;
		}
		st40:
		p+= 1;
		if ( p == pe )
		goto _test_eof40;
		st_case_40:
		if ( ( (*( p))) == 101 ) {
			goto st41;
		}
		{
			goto st0;
		}
		st41:
		p+= 1;
		if ( p == pe )
		goto _test_eof41;
		st_case_41:
		if ( ( (*( p))) == 98 ) {
			goto st42;
		}
		{
			goto st0;
		}
		st42:
		p+= 1;
		if ( p == pe )
		goto _test_eof42;
		st_case_42:
		if ( ( (*( p))) == 32 ) {
			goto ctr76;
		}
		{
			goto st0;
		}
		st43:
		p+= 1;
		if ( p == pe )
		goto _test_eof43;
		st_case_43:
		switch( ( (*( p))) ) {
			case 97: {
				goto st44;
			}
			case 117: {
				goto st46;
			}
		}
		{
			goto st0;
		}
		st44:
		p+= 1;
		if ( p == pe )
		goto _test_eof44;
		st_case_44:
		if ( ( (*( p))) == 110 ) {
			goto st45;
		}
		{
			goto st0;
		}
		st45:
		p+= 1;
		if ( p == pe )
		goto _test_eof45;
		st_case_45:
		if ( ( (*( p))) == 32 ) {
			goto ctr80;
		}
		{
			goto st0;
		}
		st46:
		p+= 1;
		if ( p == pe )
		goto _test_eof46;
		st_case_46:
		switch( ( (*( p))) ) {
			case 108: {
				goto st47;
			}
			case 110: {
				goto st48;
			}
		}
		{
			goto st0;
		}
		st47:
		p+= 1;
		if ( p == pe )
		goto _test_eof47;
		st_case_47:
		if ( ( (*( p))) == 32 ) {
			goto ctr83;
		}
		{
			goto st0;
		}
		st48:
		p+= 1;
		if ( p == pe )
		goto _test_eof48;
		st_case_48:
		if ( ( (*( p))) == 32 ) {
			goto ctr84;
		}
		{
			goto st0;
		}
		st49:
		p+= 1;
		if ( p == pe )
		goto _test_eof49;
		st_case_49:
		if ( ( (*( p))) == 97 ) {
			goto st50;
		}
		{
			goto st0;
		}
		st50:
		p+= 1;
		if ( p == pe )
		goto _test_eof50;
		st_case_50:
		switch( ( (*( p))) ) {
			case 114: {
				goto st51;
			}
			case 121: {
				goto st52;
			}
		}
		{
			goto st0;
		}
		st51:
		p+= 1;
		if ( p == pe )
		goto _test_eof51;
		st_case_51:
		if ( ( (*( p))) == 32 ) {
			goto ctr88;
		}
		{
			goto st0;
		}
		st52:
		p+= 1;
		if ( p == pe )
		goto _test_eof52;
		st_case_52:
		if ( ( (*( p))) == 32 ) {
			goto ctr89;
		}
		{
			goto st0;
		}
		st53:
		p+= 1;
		if ( p == pe )
		goto _test_eof53;
		st_case_53:
		if ( ( (*( p))) == 111 ) {
			goto st54;
		}
		{
			goto st0;
		}
		st54:
		p+= 1;
		if ( p == pe )
		goto _test_eof54;
		st_case_54:
		if ( ( (*( p))) == 118 ) {
			goto st55;
		}
		{
			goto st0;
		}
		st55:
		p+= 1;
		if ( p == pe )
		goto _test_eof55;
		st_case_55:
		if ( ( (*( p))) == 32 ) {
			goto ctr92;
		}
		{
			goto st0;
		}
		st56:
		p+= 1;
		if ( p == pe )
		goto _test_eof56;
		st_case_56:
		if ( ( (*( p))) == 99 ) {
			goto st57;
		}
		{
			goto st0;
		}
		st57:
		p+= 1;
		if ( p == pe )
		goto _test_eof57;
		st_case_57:
		if ( ( (*( p))) == 116 ) {
			goto st58;
		}
		{
			goto st0;
		}
		st58:
		p+= 1;
		if ( p == pe )
		goto _test_eof58;
		st_case_58:
		if ( ( (*( p))) == 32 ) {
			goto ctr95;
		}
		{
			goto st0;
		}
		st59:
		p+= 1;
		if ( p == pe )
		goto _test_eof59;
		st_case_59:
		if ( ( (*( p))) == 101 ) {
			goto st60;
		}
		{
			goto st0;
		}
		st60:
		p+= 1;
		if ( p == pe )
		goto _test_eof60;
		st_case_60:
		if ( ( (*( p))) == 112 ) {
			goto st61;
		}
		{
			goto st0;
		}
		st61:
		p+= 1;
		if ( p == pe )
		goto _test_eof61;
		st_case_61:
		if ( ( (*( p))) == 32 ) {
			goto ctr98;
		}
		{
			goto st0;
		}
		st62:
		p+= 1;
		if ( p == pe )
		goto _test_eof62;
		st_case_62:
		if ( ( (*( p))) == 32 ) {
			goto ctr8;
		}
		{
			goto st0;
		}
		st63:
		p+= 1;
		if ( p == pe )
		goto _test_eof63;
		st_case_63:
		if ( ( (*( p))) == 114 ) {
			goto st64;
		}
		{
			goto st0;
		}
		st64:
		p+= 1;
		if ( p == pe )
		goto _test_eof64;
		st_case_64:
		if ( ( (*( p))) == 105 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st65:
		p+= 1;
		if ( p == pe )
		goto _test_eof65;
		st_case_65:
		if ( ( (*( p))) == 44 ) {
			goto st66;
		}
		{
			goto st0;
		}
		st66:
		p+= 1;
		if ( p == pe )
		goto _test_eof66;
		st_case_66:
		if ( ( (*( p))) == 32 ) {
			goto st66;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto ctr2;
		}
		{
			goto st0;
		}
		st67:
		p+= 1;
		if ( p == pe )
		goto _test_eof67;
		st_case_67:
		if ( ( (*( p))) == 111 ) {
			goto st68;
		}
		{
			goto st0;
		}
		st68:
		p+= 1;
		if ( p == pe )
		goto _test_eof68;
		st_case_68:
		if ( ( (*( p))) == 110 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st69:
		p+= 1;
		if ( p == pe )
		goto _test_eof69;
		st_case_69:
		switch( ( (*( p))) ) {
			case 97: {
				goto st70;
			}
			case 117: {
				goto st68;
			}
		}
		{
			goto st0;
		}
		st70:
		p+= 1;
		if ( p == pe )
		goto _test_eof70;
		st_case_70:
		if ( ( (*( p))) == 116 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st71:
		p+= 1;
		if ( p == pe )
		goto _test_eof71;
		st_case_71:
		switch( ( (*( p))) ) {
			case 104: {
				goto st72;
			}
			case 117: {
				goto st73;
			}
		}
		{
			goto st0;
		}
		st72:
		p+= 1;
		if ( p == pe )
		goto _test_eof72;
		st_case_72:
		if ( ( (*( p))) == 117 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st73:
		p+= 1;
		if ( p == pe )
		goto _test_eof73;
		st_case_73:
		if ( ( (*( p))) == 101 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st74:
		p+= 1;
		if ( p == pe )
		goto _test_eof74;
		st_case_74:
		if ( ( (*( p))) == 101 ) {
			goto st75;
		}
		{
			goto st0;
		}
		st75:
		p+= 1;
		if ( p == pe )
		goto _test_eof75;
		st_case_75:
		if ( ( (*( p))) == 100 ) {
			goto st65;
		}
		{
			goto st0;
		}
		st_out:
		_test_eof1: cs = 1; goto _test_eof; 
		_test_eof2: cs = 2; goto _test_eof; 
		_test_eof3: cs = 3; goto _test_eof; 
		_test_eof4: cs = 4; goto _test_eof; 
		_test_eof5: cs = 5; goto _test_eof; 
		_test_eof6: cs = 6; goto _test_eof; 
		_test_eof7: cs = 7; goto _test_eof; 
		_test_eof8: cs = 8; goto _test_eof; 
		_test_eof9: cs = 9; goto _test_eof; 
		_test_eof10: cs = 10; goto _test_eof; 
		_test_eof11: cs = 11; goto _test_eof; 
		_test_eof12: cs = 12; goto _test_eof; 
		_test_eof13: cs = 13; goto _test_eof; 
		_test_eof14: cs = 14; goto _test_eof; 
		_test_eof15: cs = 15; goto _test_eof; 
		_test_eof16: cs = 16; goto _test_eof; 
		_test_eof17: cs = 17; goto _test_eof; 
		_test_eof18: cs = 18; goto _test_eof; 
		_test_eof19: cs = 19; goto _test_eof; 
		_test_eof20: cs = 20; goto _test_eof; 
		_test_eof76: cs = 76; goto _test_eof; 
		_test_eof77: cs = 77; goto _test_eof; 
		_test_eof21: cs = 21; goto _test_eof; 
		_test_eof22: cs = 22; goto _test_eof; 
		_test_eof23: cs = 23; goto _test_eof; 
		_test_eof78: cs = 78; goto _test_eof; 
		_test_eof79: cs = 79; goto _test_eof; 
		_test_eof24: cs = 24; goto _test_eof; 
		_test_eof80: cs = 80; goto _test_eof; 
		_test_eof25: cs = 25; goto _test_eof; 
		_test_eof81: cs = 81; goto _test_eof; 
		_test_eof82: cs = 82; goto _test_eof; 
		_test_eof26: cs = 26; goto _test_eof; 
		_test_eof83: cs = 83; goto _test_eof; 
		_test_eof27: cs = 27; goto _test_eof; 
		_test_eof84: cs = 84; goto _test_eof; 
		_test_eof85: cs = 85; goto _test_eof; 
		_test_eof28: cs = 28; goto _test_eof; 
		_test_eof86: cs = 86; goto _test_eof; 
		_test_eof87: cs = 87; goto _test_eof; 
		_test_eof29: cs = 29; goto _test_eof; 
		_test_eof88: cs = 88; goto _test_eof; 
		_test_eof30: cs = 30; goto _test_eof; 
		_test_eof89: cs = 89; goto _test_eof; 
		_test_eof90: cs = 90; goto _test_eof; 
		_test_eof31: cs = 31; goto _test_eof; 
		_test_eof91: cs = 91; goto _test_eof; 
		_test_eof32: cs = 32; goto _test_eof; 
		_test_eof92: cs = 92; goto _test_eof; 
		_test_eof93: cs = 93; goto _test_eof; 
		_test_eof94: cs = 94; goto _test_eof; 
		_test_eof33: cs = 33; goto _test_eof; 
		_test_eof34: cs = 34; goto _test_eof; 
		_test_eof35: cs = 35; goto _test_eof; 
		_test_eof36: cs = 36; goto _test_eof; 
		_test_eof37: cs = 37; goto _test_eof; 
		_test_eof38: cs = 38; goto _test_eof; 
		_test_eof39: cs = 39; goto _test_eof; 
		_test_eof40: cs = 40; goto _test_eof; 
		_test_eof41: cs = 41; goto _test_eof; 
		_test_eof42: cs = 42; goto _test_eof; 
		_test_eof43: cs = 43; goto _test_eof; 
		_test_eof44: cs = 44; goto _test_eof; 
		_test_eof45: cs = 45; goto _test_eof; 
		_test_eof46: cs = 46; goto _test_eof; 
		_test_eof47: cs = 47; goto _test_eof; 
		_test_eof48: cs = 48; goto _test_eof; 
		_test_eof49: cs = 49; goto _test_eof; 
		_test_eof50: cs = 50; goto _test_eof; 
		_test_eof51: cs = 51; goto _test_eof; 
		_test_eof52: cs = 52; goto _test_eof; 
		_test_eof53: cs = 53; goto _test_eof; 
		_test_eof54: cs = 54; goto _test_eof; 
		_test_eof55: cs = 55; goto _test_eof; 
		_test_eof56: cs = 56; goto _test_eof; 
		_test_eof57: cs = 57; goto _test_eof; 
		_test_eof58: cs = 58; goto _test_eof; 
		_test_eof59: cs = 59; goto _test_eof; 
		_test_eof60: cs = 60; goto _test_eof; 
		_test_eof61: cs = 61; goto _test_eof; 
		_test_eof62: cs = 62; goto _test_eof; 
		_test_eof63: cs = 63; goto _test_eof; 
		_test_eof64: cs = 64; goto _test_eof; 
		_test_eof65: cs = 65; goto _test_eof; 
		_test_eof66: cs = 66; goto _test_eof; 
		_test_eof67: cs = 67; goto _test_eof; 
		_test_eof68: cs = 68; goto _test_eof; 
		_test_eof69: cs = 69; goto _test_eof; 
		_test_eof70: cs = 70; goto _test_eof; 
		_test_eof71: cs = 71; goto _test_eof; 
		_test_eof72: cs = 72; goto _test_eof; 
		_test_eof73: cs = 73; goto _test_eof; 
		_test_eof74: cs = 74; goto _test_eof; 
		_test_eof75: cs = 75; goto _test_eof; 
		
		_test_eof: {}
		if ( p == eof )
		{
			switch ( cs ) {
				case 1: {
					
					break; }
				case 0: {
					
					break; }
				case 2: {
					
					break; }
				case 3: {
					
					break; }
				case 4: {
					
					break; }
				case 5: {
					
					break; }
				case 6: {
					
					break; }
				case 7: {
					
					break; }
				case 8: {
					
					break; }
				case 9: {
					
					break; }
				case 10: {
					
					break; }
				case 11: {
					
					break; }
				case 12: {
					
					break; }
				case 13: {
					
					break; }
				case 14: {
					
					break; }
				case 15: {
					
					break; }
				case 16: {
					
					break; }
				case 17: {
					
					break; }
				case 18: {
					
					break; }
				case 19: {
					
					break; }
				case 20: {
					
					break; }
				case 76: {
					
					break; }
				case 77: {
					
					break; }
				case 21: {
					
					break; }
				case 22: {
					
					break; }
				case 23: {
					
					break; }
				case 78: {
					
					break; }
				case 79: {
					
					break; }
				case 24: {
					
					break; }
				case 80: {
					
					break; }
				case 25: {
					
					break; }
				case 81: {
					
					break; }
				case 82: {
					
					break; }
				case 26: {
					
					break; }
				case 83: {
					
					break; }
				case 27: {
					
					break; }
				case 84: {
					
					break; }
				case 85: {
					
					break; }
				case 28: {
					
					break; }
				case 86: {
					
					break; }
				case 87: {
					
					break; }
				case 29: {
					
					break; }
				case 88: {
					
					break; }
				case 30: {
					
					break; }
				case 89: {
					
					break; }
				case 90: {
					
					break; }
				case 31: {
					
					break; }
				case 91: {
					
					break; }
				case 32: {
					
					break; }
				case 92: {
					
					break; }
				case 93: {
					
					break; }
				case 94: {
					
					break; }
				case 33: {
					
					break; }
				case 34: {
					
					break; }
				case 35: {
					
					break; }
				case 36: {
					
					break; }
				case 37: {
					
					break; }
				case 38: {
					
					break; }
				case 39: {
					
					break; }
				case 40: {
					
					break; }
				case 41: {
					
					break; }
				case 42: {
					
					break; }
				case 43: {
					
					break; }
				case 44: {
					
					break; }
				case 45: {
					
					break; }
				case 46: {
					
					break; }
				case 47: {
					
					break; }
				case 48: {
					
					break; }
				case 49: {
					
					break; }
				case 50: {
					
					break; }
				case 51: {
					
					break; }
				case 52: {
					
					break; }
				case 53: {
					
					break; }
				case 54: {
					
					break; }
				case 55: {
					
					break; }
				case 56: {
					
					break; }
				case 57: {
					
					break; }
				case 58: {
					
					break; }
				case 59: {
					
					break; }
				case 60: {
					
					break; }
				case 61: {
					
					break; }
				case 62: {
					
					break; }
				case 63: {
					
					break; }
				case 64: {
					
					break; }
				case 65: {
					
					break; }
				case 66: {
					
					break; }
				case 67: {
					
					break; }
				case 68: {
					
					break; }
				case 69: {
					
					break; }
				case 70: {
					
					break; }
				case 71: {
					
					break; }
				case 72: {
					
					break; }
				case 73: {
					
					break; }
				case 74: {
					
					break; }
				case 75: {
					
					break; }
			}
			switch ( cs ) {
			}
			switch ( cs ) {
				case 76: 
				{
					#line 85 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					if (p > tmp) {
						rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);
						
						if (*(tmp - 1) == '-') {
							tz = -(tz);
						}
					}
				}
				break;
				case 78: 
				
				case 79: 
				
				case 82: 
				
				case 85: 
				
				case 87: 
				
				case 90: 
				
				case 93: 
				{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 94: 
				{
					#line 138 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = 0;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 86: 
				{
					#line 141 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = 0;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 84: 
				{
					#line 144 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -500;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 83: 
				{
					#line 147 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -400;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 81: 
				{
					#line 150 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -600;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 80: 
				{
					#line 153 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -500;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 89: 
				{
					#line 156 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -700;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 88: 
				{
					#line 159 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -600;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 92: 
				{
					#line 162 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -800;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
				case 91: 
				{
					#line 165 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
					tz = -700;
				}	{
					#line 94 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/smtp_date.rl"
					
				}
				break;
			}
		}
		
		_out: {}
	}
	
	
	return rspamd_tm_to_time (&tm, tz);
}