

#include "smtp_parsers.h"
#include "mime_headers.h"


static const int rfc2047_parser_start = 1;
static const int rfc2047_parser_first_final = 18;
static const int rfc2047_parser_error = 0;

static const int rfc2047_parser_en_main = 1;

static const char _rfc2047_parser_nfa_targs[] = {
	0, 0
};

static const char _rfc2047_parser_nfa_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0
};

static const char _rfc2047_parser_nfa_push_actions[] = {
	0, 0
};

static const char _rfc2047_parser_nfa_pop_trans[] = {
	0, 0
};



gboolean
rspamd_rfc2047_parser (const gchar *in, gsize len, gint *pencoding,
const gchar **charset, gsize *charset_len,
const gchar **encoded, gsize *encoded_len)
{
	const char *p = in, *pe = in + len,
	*encoded_start = NULL, *encoded_end = NULL,
	*charset_start = NULL, *charset_end = NULL,
	*eof = in + len;
	gint encoding = RSPAMD_RFC2047_QP, cs=0;
	
	
	{
		cs = (int)rfc2047_parser_start;
	}
	
	
	{
		if ( p == pe )
		goto _test_eof;
		switch ( cs )
		{
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 9:
			goto st_case_9;
			case 18:
			goto st_case_18;
			case 10:
			goto st_case_10;
			case 19:
			goto st_case_19;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 15:
			goto st_case_15;
			case 16:
			goto st_case_16;
			case 17:
			goto st_case_17;
		}
		goto st_out;
		st_case_1:
		if ( ( (*( p))) == 61 ) {
			goto st2;
		}
		{
			goto st0;
		}
		st_case_0:
		st0:
		cs = 0;
		goto _out;
		st2:
		p+= 1;
		if ( p == pe )
		goto _test_eof2;
		st_case_2:
		if ( ( (*( p))) == 63 ) {
			goto st3;
		}
		{
			goto st0;
		}
		st3:
		p+= 1;
		if ( p == pe )
		goto _test_eof3;
		st_case_3:
		switch( ( (*( p))) ) {
			case 33: {
				goto ctr3;
			}
			case 43: {
				goto ctr3;
			}
			case 45: {
				goto ctr3;
			}
			case 92: {
				goto ctr3;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 35 <= ( (*( p))) && ( (*( p))) <= 39 ) {
				goto ctr3;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto ctr3;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto ctr3;
			}
		} else {
			goto ctr3;
		}
		{
			goto st0;
		}
		ctr3:
		{
			#line 5 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			charset_start = p;
		}
		
		goto st4;
		st4:
		p+= 1;
		if ( p == pe )
		goto _test_eof4;
		st_case_4:
		switch( ( (*( p))) ) {
			case 33: {
				goto st4;
			}
			case 42: {
				goto ctr5;
			}
			case 43: {
				goto st4;
			}
			case 45: {
				goto st4;
			}
			case 63: {
				goto ctr6;
			}
			case 92: {
				goto st4;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 35 <= ( (*( p))) && ( (*( p))) <= 39 ) {
				goto st4;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto st4;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto st4;
			}
		} else {
			goto st4;
		}
		{
			goto st0;
		}
		ctr5:
		{
			#line 9 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			if (charset_start && p > charset_start) {
				charset_end = p;
			}
		}
		
		goto st5;
		st5:
		p+= 1;
		if ( p == pe )
		goto _test_eof5;
		st_case_5:
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st6;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st6;
		}
		{
			goto st0;
		}
		st6:
		p+= 1;
		if ( p == pe )
		goto _test_eof6;
		st_case_6:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st11;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st11;
		}
		{
			goto st0;
		}
		ctr6:
		{
			#line 9 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			if (charset_start && p > charset_start) {
				charset_end = p;
			}
		}
		
		goto st7;
		st7:
		p+= 1;
		if ( p == pe )
		goto _test_eof7;
		st_case_7:
		switch( ( (*( p))) ) {
			case 66: {
				goto st8;
			}
			case 81: {
				goto st8;
			}
			case 98: {
				goto st8;
			}
			case 113: {
				goto st8;
			}
		}
		{
			goto st0;
		}
		st8:
		p+= 1;
		if ( p == pe )
		goto _test_eof8;
		st_case_8:
		if ( ( (*( p))) == 63 ) {
			goto ctr12;
		}
		{
			goto st0;
		}
		ctr12:
		{
			#line 15 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			if (p > in) {
				switch (*(p - 1)) {
					case 'B':
					case 'b':
					encoding = RSPAMD_RFC2047_BASE64;
					break;
					default:
					encoding = RSPAMD_RFC2047_QP;
					break;
				}
			}
		}
		
		goto st9;
		st9:
		p+= 1;
		if ( p == pe )
		goto _test_eof9;
		st_case_9:
		if ( ( (*( p))) > 62 ) {
			if ( 64 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto ctr13;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto ctr13;
		}
		{
			goto st0;
		}
		ctr13:
		{
			#line 29 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			encoded_start = p;
		}
		
		goto st18;
		st18:
		p+= 1;
		if ( p == pe )
		goto _test_eof18;
		st_case_18:
		if ( ( (*( p))) == 63 ) {
			goto ctr22;
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto st18;
		}
		{
			goto st0;
		}
		ctr22:
		{
			#line 33 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
			
			if (encoded_start && p > encoded_start) {
				encoded_end = p;
			}
		}
		
		goto st10;
		st10:
		p+= 1;
		if ( p == pe )
		goto _test_eof10;
		st_case_10:
		if ( ( (*( p))) == 61 ) {
			goto st19;
		}
		{
			goto st0;
		}
		st19:
		p+= 1;
		if ( p == pe )
		goto _test_eof19;
		st_case_19:
		{
			goto st0;
		}
		st11:
		p+= 1;
		if ( p == pe )
		goto _test_eof11;
		st_case_11:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st12;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st12;
		}
		{
			goto st0;
		}
		st12:
		p+= 1;
		if ( p == pe )
		goto _test_eof12;
		st_case_12:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st13;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st13;
		}
		{
			goto st0;
		}
		st13:
		p+= 1;
		if ( p == pe )
		goto _test_eof13;
		st_case_13:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st14;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st14;
		}
		{
			goto st0;
		}
		st14:
		p+= 1;
		if ( p == pe )
		goto _test_eof14;
		st_case_14:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st15;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st15;
		}
		{
			goto st0;
		}
		st15:
		p+= 1;
		if ( p == pe )
		goto _test_eof15;
		st_case_15:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st16;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st16;
		}
		{
			goto st0;
		}
		st16:
		p+= 1;
		if ( p == pe )
		goto _test_eof16;
		st_case_16:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto st17;
			}
		} else if ( ( (*( p))) >= 65 ) {
			goto st17;
		}
		{
			goto st0;
		}
		st17:
		p+= 1;
		if ( p == pe )
		goto _test_eof17;
		st_case_17:
		switch( ( (*( p))) ) {
			case 45: {
				goto st5;
			}
			case 63: {
				goto st7;
			}
		}
		{
			goto st0;
		}
		st_out:
		_test_eof2: cs = 2; goto _test_eof; 
		_test_eof3: cs = 3; goto _test_eof; 
		_test_eof4: cs = 4; goto _test_eof; 
		_test_eof5: cs = 5; goto _test_eof; 
		_test_eof6: cs = 6; goto _test_eof; 
		_test_eof7: cs = 7; goto _test_eof; 
		_test_eof8: cs = 8; goto _test_eof; 
		_test_eof9: cs = 9; goto _test_eof; 
		_test_eof18: cs = 18; goto _test_eof; 
		_test_eof10: cs = 10; goto _test_eof; 
		_test_eof19: cs = 19; goto _test_eof; 
		_test_eof11: cs = 11; goto _test_eof; 
		_test_eof12: cs = 12; goto _test_eof; 
		_test_eof13: cs = 13; goto _test_eof; 
		_test_eof14: cs = 14; goto _test_eof; 
		_test_eof15: cs = 15; goto _test_eof; 
		_test_eof16: cs = 16; goto _test_eof; 
		_test_eof17: cs = 17; goto _test_eof; 
		
		_test_eof: {}
		if ( p == eof )
		{
			switch ( cs ) {
				case 1: {
					
					break; }
				case 0: {
					
					break; }
				case 2: {
					
					break; }
				case 3: {
					
					break; }
				case 4: {
					
					break; }
				case 5: {
					
					break; }
				case 6: {
					
					break; }
				case 7: {
					
					break; }
				case 8: {
					
					break; }
				case 9: {
					
					break; }
				case 18: {
					
					break; }
				case 10: {
					
					break; }
				case 19: {
					
					break; }
				case 11: {
					
					break; }
				case 12: {
					
					break; }
				case 13: {
					
					break; }
				case 14: {
					
					break; }
				case 15: {
					
					break; }
				case 16: {
					
					break; }
				case 17: {
					
					break; }
			}
			switch ( cs ) {
			}
			switch ( cs ) {
				case 18: 
				{
					#line 33 "/home/hanzlik/rpmbuild/BUILD/rspamd-1.8.1/src/ragel/rfc2047_parser.rl"
					
					if (encoded_start && p > encoded_start) {
						encoded_end = p;
					}
				}
				break;
			}
		}
		
		_out: {}
	}
	
	
	if (encoded_end) {
		*pencoding = encoding;
		*charset = charset_start;
		*charset_len = charset_end - charset_start;
		*encoded = encoded_start;
		*encoded_len = encoded_end - encoded_start;
		
		return TRUE;
	}
	
	return FALSE;
}
